org.apache.commons.compress.utils

## Class CountingInputStream

- java.lang.Object
- - java.io.InputStream
  - - java.io.FilterInputStream
    - - org.apache.commons.compress.utils.CountingInputStream

- All Implemented Interfaces:
    Closeable, AutoCloseable

      public class CountingInputStream
      extends FilterInputStream

  Input stream that tracks the number of bytes read.
  Since:
    1.3
  This class is not thread-safe

- - ### Field Summary

    - ### Fields inherited from class java.io.FilterInputStream

      `in`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CountingInputStream(InputStream in)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `count(long read)` Increments the counter of already read bytes.
    `long` | `getBytesRead()` Returns the current number of bytes read from this stream.
    `int` | `read()`
    `int` | `read(byte[] b)`
    `int` | `read(byte[] b, int off, int len)`

    - ### Methods inherited from class java.io.FilterInputStream

      `available, close, mark, markSupported, reset, skip`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CountingInputStream

          public CountingInputStream(InputStream in)

  - ### Method Detail

    - #### count

          protected final void count(long read)

      Increments the counter of already read bytes. Doesn't increment if the EOF has been hit (read == -1)
      Parameters:
        `read` - the number of bytes read

    - #### getBytesRead

          public long getBytesRead()

      Returns the current number of bytes read from this stream.
      Returns:
        the number of read bytes

    - #### read

          public int read()
                   throws IOException

      Overrides:
        `read` in class `FilterInputStream`
      Throws:
        `IOException`

    - #### read

          public int read(byte[] b)
                   throws IOException

      Overrides:
        `read` in class `FilterInputStream`
      Throws:
        `IOException`

    - #### read

          public int read(byte[] b,
                          int off,
                          int len)
                   throws IOException

      Overrides:
        `read` in class `FilterInputStream`
      Throws:
        `IOException`

Copyright © 2002–2022 The Apache Software Foundation. All rights reserved.